{{ping_sweep_range}}

CON
 _clkmode = xtal1 + pll16x
 _xinfreq = 5_000_000
  
  PingServo = 0    ' servo pin
  Ping      = 1    ' ping pin
  LimitLeft = 2330 'this gen the 2.0 msec pulse for position of 180 deg. you will have to adjust for your ping servo
  LimitRight = 410 'this gen the 1.0 msec pulse for position of 0 deg. you will have to adjust for your ping servo
  Increment = 15 'step 15 each time... out of 1920. Total of 128 steps to complete 180 deg... = ~ 1.4 deg of resolution

OBJ
 nping: "ping" 'this object can be downloaded from the object exc.

VAR
 
 long Time
 long SweepInc
 long SweepDir
 
 long Stack[250]
 
PUB StartPing(addrRANGE, addrPingDir) 'called from top object
  cognew(Getdist(addrRANGE, addrPingDir), @Stack) 'kick off cog
  

PUB Getdist(addrRANGE, addrPingDir) | itrial, PingDar
  SweepInc := Increment 'set SweepInc to 30
  long[addrPingDir] := LimitRight ' pointer set to 410, or 0 deg
  pingdar := LimitRight  'set ping to 0 deg
  
  
repeat
  

  itrial := 0 'this sets range to 0 each time thru
   If PingDar == LimitRight 'if pingdar = 0 deg, sweep direction = 0 (positive)
     SweepDir := 0

   elseif PingDar == LimitLeft 'if pingdar = 180 deg, sweep direction = 1 (neg)
     SweepDir := 1

   If SweepDir == 1  'if dir is neg, subtract sweepinc from pingdar
     PingDar := PingDar - sweepinc
     long[addrPingDir] := PingDar 'pointer set to temp value
     
   elseif SweepDir == 0  'if dir is pos, add sweepinc from pingdar
    PingDar := PingDar + sweepinc
    long[addrPingDir] := PingDar 'pointer set to temp value
    
   
   dira[PingServo]~~  'pin 0 set to output
   outa[PingServo]~   'pin 0 set to 0
   time := Pingdar * 80 'time will corrispond 1 and 2 msec to move ping to exact loc
   Outa[PingServo]~~   'pin 0 set to 1
   waitcnt(time + cnt) 'wait time corrisponds between 1 to 2 msec
   outa[PingServo]~    'pin 0 set to 0
   waitcnt(1_600_000 + cnt) 'wait 20 msec

   itrial := nPing.Centimeters(Ping) 'get range info, in cm
   long[addrRANGE] := itrial   'save temp range to pointer
   waitcnt(clkfreq/10000 + cnt)   'pause to slow scan rate. max 500k, make lower to slow scan
  